package minecraft.gui.mvc;

import minecraft.player.InvalidCharacterParamsException;
import minecraft.player.Steve;

import java.util.ArrayList;
import java.util.List;

public class SteveService {
    private List<Steve> steves = new ArrayList<>();

    public void createSteve(String name, int health, int maxHealth, int attackPower,
                            int defensePower, int hunger, int maxHunger, boolean godMode)
            throws InvalidCharacterParamsException {
        Steve steve = new Steve(name, health, maxHealth, attackPower, defensePower,
                hunger, maxHunger, godMode);
        steves.add(steve);
    }

    public List<Steve> getAllSteves() {
        return new ArrayList<>(steves);
    }

    public void updateSteve(int index, String name, int health, int maxHealth,
                            int attackPower, int defensePower, int hunger,
                            int maxHunger, boolean godMode)
            throws InvalidCharacterParamsException {
        Steve updated = new Steve(name, health, maxHealth, attackPower, defensePower,
                hunger, maxHunger, godMode);
        steves.set(index, updated);
    }

    public void deleteSteve(int index) {
        steves.remove(index);
    }

    public Steve getSteve(int index) {
        return steves.get(index);
    }
}

